using MongoDB.Bson;
using MongoDB.Bson.Serialization.Attributes;

namespace Todo.Persistence.Mongo.Repositories.Dtos;

public record MongoTodo
{
    [BsonId]
    [BsonRepresentation(BsonType.ObjectId)]
    public string Id { get; init; }

    [BsonRequired]
    public string Title { get; init; }

    public string? Description { get; init; }

    [BsonRequired]
    public bool Status { get; set; }

    public string? ProjectName { get; set; } = string.Empty;
    public string AuthorId { get; set; }
    public long Created { get; set; } = 0;
    public string? Priority { get; set; } = string.Empty; 

    public Core.Entities.Todo To() => new(
        Id,
        Title,
        Status,
        ProjectName,
        AuthorId,
        Description,
        Created,
        Priority);
}