import {
  BaseQueryFn,
  FetchArgs,
  fetchBaseQuery,
  FetchBaseQueryError,
} from "@reduxjs/toolkit/query/react";

export const getApiBaseUrl = () =>
  process.env.NEXT_PUBLIC_SERVER_URL || "http://localhost:5000";

const baseQuery = fetchBaseQuery({
  baseUrl: getApiBaseUrl(),
  credentials: "include",
});
export const baseQueryWithReauth: BaseQueryFn<
  string | FetchArgs,
  unknown,
  FetchBaseQueryError
> = async (args, api, extraOptions) => {
  let result = await baseQuery(args, api, extraOptions);
  if (result.error && result.error.status === 302) {
    window.location.href = `${getApiBaseUrl()}/api/auth/login?returnUrl=${
      window.location.href
    }`;
  }
  return result;
};
